
#include <stdio.h>
#include <string.h>


/* 
  ricerca la posizione di un carattere in una stringa
  restituisce -1 se non viene trovato
*/
int cerca(char stringa[], char carattere)
{
 int i;
 
 i = 0;
 while (stringa[i] != '\0')
      {
	   if (stringa[i] == carattere)
	     return i; // trovato
	   i++;
      }
 return -1; // non trovato
}

/*
  converte una stringa nel corrispondente valore numerico senza effettuare controlli sulla correttezza
*/
float valore(char stringa[])
{
 float valore, potenza;
 int primo, punto, i, n;

 // verifica presenza segno iniziale: imposta indice prima cifra numerica
 if (stringa[0] == '+' || stringa[0] == '-')
   primo = 1;
 else
	 primo = 0;

 // ricerca posizione separatore decimale
 punto = cerca(stringa, '.');
 if (punto < 0) // valore intero
   n = strlen(stringa);
 else
	 n = punto;

 // calcolo parte intera
 valore = 0;
 potenza = 1;
 for (i=n-1; i>=primo; i--) // ciclo di scorrimento delle singole cifre
    {
     valore += (stringa[i]-'0')*potenza;
     potenza *= 10;
    }
 // calcolo parte decimale
 if (punto >= 0)
   {
    n = strlen(stringa);
    potenza = .1;
    for (i=punto+1; i<n; i++) // ciclo di scorrimento delle singole cifre
	   {
	    valore += (stringa[i]-'0')*potenza;
		potenza /= 10;
	   }
   }

 // determinazione segno risultato se negativo
 if (primo > 0 && stringa[0] == '-')
   valore = -valore;
 return valore;
}


int main(int argc, char* argv[])
{
 float val;

 if (argc != 2)
   {
    printf("Argomento mancante\r\n");
	return 0;
   }

 val = valore(argv[1]);
 printf("Il valore e' %f\r\n", val);
 return 1;
}
