
#include <string.h>
#include "soundex.h"

void Soundex(char string[], char* soundex)
{
 unsigned int string_index, soundex_index;

 if (strlen(string) < 1)
   {
    soundex[0] = '\0'; // stringa vuota come risultato
	return;
   }
 soundex[0] = string[0]; // copia primo carattere
 soundex_index = 1;
 // ciclo di scorrimento dei caratteri della stringa e di applicazione delle regole
 for (string_index=1; string_index<strlen(string); string_index++)
    {
	 switch (string[string_index])
	       {
	        case 'a':
			case 'A':
			case 'e':
			case 'E':
			case 'h':
			case 'H':
			case 'i':
			case 'I':
			case 'o':
			case 'O':
			case 'u':
			case 'U':
			case 'w':
			case 'W':
			case 'y':
			case 'Y':
			default:	break; // caratteri da omettere

			case 'b':
			case 'B':
			case 'f':
			case 'F':
			case 'p':
			case 'P':
			case 'v':
			case 'V':	if (soundex[soundex_index-1] != '1') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '1';
						   soundex_index++;
						  }
						break;
			case 'c':
			case 'C':
			case 'g':
			case 'G':
			case 'j':
			case 'J':
			case 'k':
			case 'K':
			case 'q':
			case 'Q':
			case 's':
			case 'S':
			case 'x':
			case 'X':
			case 'z':
			case 'Z':	if (soundex[soundex_index-1] != '2') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '2';
						   soundex_index++;
						  }
						break;
			case 'd':
			case 'D':
			case 't':
			case 'T':	if (soundex[soundex_index-1] != '3') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '3';
						   soundex_index++;
						  }
						break;
			case 'l':
			case 'L':	if (soundex[soundex_index-1] != '4') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '4';
						   soundex_index++;
						  }
						break;
			case 'm':
			case 'M':
			case 'n':
			case 'N':	if (soundex[soundex_index-1] != '5') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '5';
						   soundex_index++;
						  }
						break;
			case 'r':
			case 'R':	if (soundex[soundex_index-1] != '6') // non inserisce se uguale a precedente
						  {
						   soundex[soundex_index] = '6';
						   soundex_index++;
						  }
						break;
	       } // fine switch
    } // fine for
 // inserisce caratteri '0' se inferiore ai 4 caratteri
 if (soundex_index <=3)
   for (; soundex_index<=3; soundex_index++)
      soundex[soundex_index] = '0';
 soundex[4] = '\0'; // carattere di fine stringa
 return;
}
